# ECLAT

This is Mohammed J. Zaki's eclat implementation, only updated to compile on
modern C++ compilers.

## Programs

- eclat: Is a clean version of only eclat code
- assocFB: Has all algorithms (eclat, clique, maxeclat, maxclique)

## Steps

1. Generate a data file using the IBM data generator program, gen or start with
an ascii file (see chess.ascii example file in this repository). The format
of the ascii/binary file should be:
   ```
   <cid> <tid> <numitem> <item list>
   ```

2. If ascii file, first convert to binary using makebin. Binary file *MUST* have
.data extension.
    ```
    makebin chess.ascii chess.data
    ```

3. Get configuration by running getconf (gen automatically generates conf file,
so this step can be skipped)
    ```Bash
    getconf -i chess -o chess -a
    ```

Before running the rest you should now have the following files:

  *  chess.data
  *  chess.conf

4. Run: exttpose -i XXX -o XXX -l -s LMINSUP -a 0, for example:
    ```Bash
    exttpose -i chess -o chess -l -s 0 -a 0
    ```

Note: this produces the files XXX.tpose, and XXX.idx

The XXX.tpose file is the DB in vertical format, and XXX.idx is an index file
specifying where the tid-list for each item begins.

You can specify a value of LMINSUP to be the same as the one you will use to run
eclat below, in which case you will have to rerun exttpose each time you use a
new lower MINSUP. Alternatively, you can use a small value for LMINSUP, and it
will continue to work for all values of MINSUP >= LMINSUP when you run elcat.

The time for inverting is stored in summary.out. The format is: TPOSE
DB\_FILENAME X NUMITEMS TOTAL\_TIME. (see note on TOTAL\_TIME below)

You should now have the following files:

  * chess.data
  * chess.conf
  * chess.tpose
  * chess.idx

5. Run eclat
    ```Bash
    eclat -i XXX -e 1 -s <MINSUP> -d -l
    ```
Where: 
```
 -d to use diffsets instead of tidsets (only from pass 3)
 -l use tidset of pass 2 but then use diffsets after that
        (this should NOT be used for sparse datasets, since tidset
         size of pass 2 is smaller than diffset size for
         sparse sets. Thus one would omit this option for
         any dataset generated by IBM gen)
```

MINSUP is in fractions, i.e., specify 0.5 if you want 50% minsup or 0.01 if you
want 1% support.

Note that the summary of the run is stored in the summary.out file. The format
of this file is as follows:

Note3: -e 1 option is a flag indicating eclat to compute the support of
2-itemsets from scratch. The number 1 says there is only one DB partition that
will be inverted entirely in main memory. If the original DB is large then this
inversion will obviously take too much time. So in this case I recommend
dividing the DB into chunks of size roughly 5MB (assuming there is 32MB
available to the process). The exttpose program is equipped to handle this case.
If you specify a <-p NUMPART> flag to exttpose it will divide the DB into
NUMPART chunks. Now you can run eclat with -e NUMPART option. You must do this
if the DB is large otherwise the timings for eclat will be skewed. Generally,
the more the partitions the better the running time for eclat. For example:

```Bash
exttpose -i XXX -o XXX -l -a 0 -s LMINSUP -p 10
eclat -i XXX -s MINSUP -e 10
```

In summary run
eclat -i chess -e 1 -s 0.8 -d -l
since chess is a dense set I have turned on -l option

## ORIGINAL ECLAT/CLIQUE/MAX-ECLAT/MAX\_CLIQUE
run:

```Bash
  assocFB -e 1 -i XXX -s <MINSUP> -t 1000 for ECLAT
  assocFB -e 1 -i XXX -s <MINSUP> for MAXECLAT
  assocFB -e 1 -i XXX -s <MINSUP> -c -t 1000 for CLIQUE
  assocFB -e 1 -i XXX -s <MINSUP> -c for MAXCLIQUE
  ```
